iDefense Security Advisory 12.21.05: Macromedia JRun 4 Web Server URL Parsing Buffer Overflow Vulnerability Dec 21 2005 09:37PM
labs-no-reply (at) idefense (dot) com [email concealed] (labs-no-reply idefense com)
Macromedia JRun 4 Web Server URL Parsing Buffer Overflow Vulnerability

iDefense Security Advisory 12.21.05
December 21, 2005


Macromedia JRun 4 is an application server used for developing and
deploying Java based applications. More information can be found at
the following URL:



Remote exploitation of a buffer overflow vulnerability in Adobe Inc.'s
JRun 4 may allow attackers to execute arbitrary code or cause a denial
of service condition.

The vulnerability exists within the JRun web server, specifically in the
handling of long request strings. In certain configurations, when a long
(approximately 64k) URL is supplied, a stack-based overflow occurs
potentially allowing the execution of arbitrary code. In testing
performed by iDefense Labs, it was possible to overwrite the saved
return address on the stack with remotely supplied values (converted
into 'wide characters' by the server).


Successful exploitation may allow remote attackers to execute arbitrary
code with Local System privileges. The supplied JRun web server must be
active for the attack vector to exist. It is not recommended to use the
JRun web server component in production systems, as the installer
mentions that it should be used for development only.

As the service restarts after each crash, it is possible to make
multiple attempts to exploit this issue, and each time restart from a
'clean' state.

Although this vulnerability allows a stack overwrite, it may be more
difficult to exploit due the input string being converted into a 'wide
character' version of the str input, by placing a null byte between
each character. While this does not necessarily prevent exploitation, it
does increase the complexity of developing an exploit.

Exploitation of this vulnerability may allow a remote attacker to
execute code on the affected system as Local System, allowing complete
compromise, or cause a denial of service against the affected system,
preventing legitimate use.


This vulnerability was confirmed by the vendor to affect the JRun 4
webserver server prior to the JRun 4 Updater 5 release in March of 2005.


The JRun documentation suggests that the JRun Web Server should not be
used in a production environment. In a development environment, the
JRun server should not accept connections from outside of the
development network.


Adobe has reported that this issue was resolved in the JRun 4 Updater 5
release in March 2005.

The following security advisory was released on December 15, 2005:



A Mitre Corp. Common Vulnerabilities and Exposures (CVE) number has not
been assigned yet.


08/25/2004 Initial vendor notification
08/31/2004 Initial vendor response
12/21/2005 Public disclosure


The discoverer of this vulnerability wishes to remain anonymous.

Get paid for vulnerability research

Free tools, research and upcoming events


Copyright © 2005 iDefense, Inc.

Permission is granted for the redistribution of this alert
electronically. It may not be edited in any way without the express
written consent of iDefense. If you wish to reprint the whole or any
part of this alert in any other medium other than electronically, please
email customerservice (at) idefense (dot) com [email concealed] for permission.

Disclaimer: The information in the advisory is believed to be accurate
at the time of publishing based on currently available information. Use
of the information constitutes acceptance for use in an AS IS condition.
There are no warranties with regard to this information. Neither the
author nor the publisher accepts any liability for any direct, indirect,
or consequential loss or damage arising from use of, or reliance on,
this information.

[ reply ]


Privacy Statement
Copyright 2010, SecurityFocus